'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (_ref3) {
  var t = _ref3.types;

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(path) {
        var node = path.node;
        var specifiers = node.specifiers;
        var source = node.source;
        var pkgId = source.value;

        var specs = [];

        if (pkgId !== recharts) {
          return;
        }

        if (!specifiers.filter(t.isImportSpecifier).length) {
          return;
        }

        specifiers.forEach(function (spec) {
          var _spec = spec;
          var local = _spec.local;
          var imported = _spec.imported;
          var localName = local.name;


          var importedPath = recharts;

          if (t.isImportSpecifier(spec)) {
            var importedName = imported.name;


            spec = t.importDefaultSpecifier(t.identifier(localName));

            if (!pkgMap[importedName]) {
              throw new Error('Recharts ' + importedName + ' was not in known modules.');
            }

            importedPath += pkgMap[importedName];
          }

          path.insertAfter(t.importDeclaration([spec], t.stringLiteral(importedPath)));
        });

        path.remove();
      }
    }
  };
};

var _module2 = require('module');

var _module3 = _interopRequireDefault(_module2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var recharts = 'recharts';
var rechartsLib = 'recharts/lib';

var _module = new _module3.default();

var rechartsPath = _path2.default.dirname(_module3.default._resolveFilename('recharts', _extends({}, _module, {
  paths: _module3.default._nodeModulePaths(process.cwd())
})));

var indexFile = _fs2.default.readFileSync(rechartsPath + '/../src/index.js', 'utf-8');
var regStr = 'export ([\\S]+) from \'([\\S]+)\';';

var regx = new RegExp(regStr);
var globalRegx = new RegExp(regStr, 'g');

var pkgMap = indexFile.match(globalRegx).map(function (exp) {
  return exp.match(regx).slice(1);
}).reduce(function (result, _ref) {
  var _ref2 = _slicedToArray(_ref, 2);

  var pkgId = _ref2[0];
  var path = _ref2[1];

  return _extends({}, result, _defineProperty({}, pkgId, path.slice(1)));
}, {});